<template>
  <div class="accordion">
    <button @click="open()">
      <i
        :class="[
          'bx',
          'bxs-chevron-right',
          visible == true
            ? 'accordion-arrow--active'
            : 'accordion-arrow--deactive',
        ]"
      ></i>
      <slot name="title" />
    </button>
    <transition
      name="accordion"
      @enter="start"
      @after-enter="end"
      @before-leave="start"
      @after-leave="end"
    >
      <div v-show="visible">
        <slot name="content" />
      </div>
    </transition>
  </div>
</template>

<script>
export default {
  data() {
    return {
      accordion: {
        count: 0,
        active: null,
      },
      index: null,
    };
  },
  computed: {
    visible() {
      return this.index == this.accordion.active;
    },
  },

  methods: {
    open() {
      if (this.visible) {
        this.accordion.active = null;
      } else {
        this.accordion.active = this.index;
      }
    },
    start(el) {
      el.style.height = el.scrollHeight + "px";
    },
    end(el) {
      el.style.height = "";
    },
  },

  created() {
    this.index = this.accordion.count++;
  },
};
</script>

<style lang="scss" scoped>
.accordion {
  padding: 0px 20px 0px 10px;
  border-bottom: 1px solid #ebebeb;
  transition: all ease 0.3s;
  &:hover {
    cursor: pointer;
    background-color: #b8cff01f;
  }

  i {
    font-size: 17px;
    font-weight: 900;
    margin-right: 10px;
    transition: all ease 0.3s;
  }
  button {
    padding: 20px 0;
    width: 100%;
    font-size: 16px;
    font-weight: 900;
    background: none;
    display: flex;
    align-items: center;
    justify-content: flex-start;
  }
  &-arrow--active {
    transform: rotate(90deg);
  }
  &-arrow--deactive {
    transform: rotate(0deg);
  }
}
.accordion-enter-active,
.accordion-leave-active {
  will-change: height, opacity;
  transition: height 0.3s ease, opacity 0.3s ease;
  overflow: hidden;
}

.accordion-enter,
.accordion-leave-to {
  height: 0 !important;
  opacity: 0;
}
</style>
